/*-----------------------------------------------------------------------------
 * port.h 
 * Low level I/O functions taken from led-stat.txt
 * Jan 22 95
 *
 * Taken again 19 March 1996 from meter-0.2
 *
 * Taken once again 5 April 1998 ryan yeske (thanks)
 *
 * Taken once more 20 Sepetmber 2001 dan williams (thanks yeske)
 *
 */

/*
 Two files were used: the first is a routine written by a roomate
 (damianf@wpi.edu) used to blast raw bytes at a port, and read them. Please
 contact him for more info, or if you want to use it in a progrm of your own.
 
 **NOTE: i tried to contact damian@wpi.edu, but the mail was returned
 **unknown user. (rcy)
 */


#ifndef PORT_H
#define PORT_H

/*
  Comments from the concept doc, Dan williams

port controller:

 DATA
 - array of port objects

 METHODS
 - (porthandle) int Open  ( port address )
 - (ErrorCode)  int Write ( port handle, data, bitMask (mask of the bits to actually change) )
 -              int Read  ( port handle )
 -                  Close ()
 
 
port object:

 DATA
 - handle
 - port address
 - port log
 
 METHODS
 -     Write ( data );
 - int Read  ();


pardon the non-oop

*/


static inline int port_in( int port )
{
   unsigned char value;
  __asm__ volatile ("inb %1,%0"
                    : "=a" (value)
                    : "d" ((unsigned short)port));
   return value;
}

static inline void port_out( unsigned short int port, unsigned char val )
{
  __asm__ volatile (
                    "outb %0,%1\n"
                    :
                    : "a" (val), "d" (port)
                    );
}

// not finished and hacked, version 0. DW
int portCommander_Open( int Address ){

    if ((ioperm(Address, 3, 1)) == -1) { 
      return NULL;
    }
	 
    return Address;
}

// not finished, version 0. DW
int portCommander_Write ( int handle, unsigned char data, unsigned char bitMask ) {
  port_out( handle, data );
  return 1;
}

// not finished, version 0. DW
int portCommander_Read ( int handle ) {
  return port_in( handle );
}

// not finished, version 0. DW
void portCommander_Close ( int handle ) {
  return;
}


#endif /* PORT_H */
/**** END OF FILE ****/
